import { system } from "@minecraft/server";

const tickIntervalMap = new Map();
let tickIntervalID = 0;
let totalTick = 0
system.runInterval(() => {
    totalTick++;
    for (const [, tickInterval] of tickIntervalMap) {
        if (totalTick % tickInterval.tick === 0)
            tickInterval.callback(...tickInterval.args);
    }
}, 1);

export function setTickInterval(handler, timeout, firstTick, ...args) {
    const tickInterval = { callback: handler, tick: timeout, args };
    tickIntervalID++;
    tickIntervalMap.set(tickIntervalID, tickInterval);
    if (firstTick ?? true)
        try {
            handler(0);
        }
        catch (e) {
            console.warn(e + e.stack);
        }
    return tickIntervalID;
}