import { world } from "@minecraft/server";
import client from "../ServerClient";

let run = undefined

export class Chat {
    on(callback) {
        run = world.beforeEvents.chatSend.subscribe(data => {
            const player = client.player.convert(data.sender)
            const { message } = data
            callback(player, {
                message: message,
                cancel() {
                    data.cancel = true;
                }
            })
        });
        return this;
    }
    off() {
        world.beforeEvents.chatSend.unsubscribe(run);
    }
}