import { world } from "@minecraft/server";
import client from "../ServerClient";

let run = undefined

export class ProjectileHit {
    on(callback) {
        run = world.afterEvents.projectileHit.subscribe((data) => {
            let src;
            if (data.source?.typeId == 'minecraft:player') {
                src = client.player.convert(data.source)
            }
            callback(Object.assign(data, { src }))
        });
        return this;
    }
    off() {
        return world.afterEvents.projectileHit.unsubscribe(run);
    }
}