import client from "./ServerClient"
import { system } from "@minecraft/server"

let lastTick = Date.now()
let tps = 20
let timeArray = []

system.runInterval(() => {
  if (timeArray.length === 20) timeArray.shift()
  timeArray.push(Math.round(1000 / (Date.now() - lastTick) * 100) / 100)
  tps = timeArray.reduce((a, b) => a + b) / timeArray.length
  lastTick = Date.now()
})

export class Extra {
    parseNumber(value) {
        const types = ["", "k", "M", "B", "T", "P", "E", "Z", "Y"];
        let selectType = 0;
        let scaled = value;
        while (scaled >= 1000 && selectType < types.length - 1) {
          scaled /= 1000;
          selectType++;
        }
        return scaled.toFixed(1) + types[selectType];
    }
    tps() {
        return tps.toFixed(1)
    }
    broadcast(message) {
        return client.send(`§8[§cBroadcast§8] §r§6${message}`)
    }
}