import { database } from "../ServerClient.js";


export class Ban {
    constructor() {
        this.database = database.register('ban')
    }
    newBan(sender, player, reason) {
        if (player.name == sender.name) return sender.response.error('You cant ban yourself')
        if (player.permission.hasPermission('admin')) return sender.response.error('You cant ban a staff member')
        if (this.database.has(player.name)) return sender.response.error(`§6${player.name} §cis already banned`)
        const Data = {
            name: player.name,
            date: new Date().toLocaleString(),
            reason: reason,
            by: sender.name
        }
        this.database.write(player.name, Data)
        sender.response.send(`You have banned the player ${player.name} §cReason: ${reason}`)
    }

    unban(sender, player) {
        const getplayer = this.database.has(player.name)
        if (!getplayer) return sender.response.error(`§6${player.name} §cisnt banned`)
        sender.response.send(`You have unbanned the player ${player.name}`)
        this.database.delete(player.name)
    }

    banview(sender, player) {    
        const getplayer = this.database.has(player)
        if (!player) return sender.response.error('You must type a banned players name to view')
        if (!getplayer) return sender.response.error('You must type a players name that is banned')
        const data = this.database.read(player)
        let text = '\n'
        text += `§cName: ${data.name} \n§r§cBanned by: ${data.by} \n§r§cBanned at: ${data.date} \n§r§cReason: ${data.reason}`
        sender.response.send(`§cViewing the banned player §6${player}§r§c:${text}`, true, false)
    }

    banlist(sender) {
        if (!this.database.allKeys().length) return sender.response.error('There are no banned players')
        sender.response.send(`§c----------------\nBanned players:${this.database.allKeys()}\n§c----------------`, true, false)
    }
}