import { database } from "../ServerClient";

export class Enchantment {
    constructor() {
        this.database = database.register('enchantments')
    }
    create(info) {
        return this.database.write(info.name, {
            name: info.name,
            description: info.description,
            equpiedOn: info.equpiedOn,
            maxLevel: info.maxLevel,
            event: info.event,
            tier: info.tier,
            command: info.command
        })
    }
    convertToRoman(num) {
        const roman = {
            M: 1000,
            CM: 900,
            D: 500,
            CD: 400,
            C: 100,
            XC: 90,
            L: 50,
            XL: 40,
            X: 10,
            IX: 9,
            V: 5,
            IV: 4,
            I: 1
        };
        let str = '';
        for (var i of Object.keys(roman)) {
            var q = Math.floor(num / roman[i]);
            num -= q * roman[i];
            str += i.repeat(q)
        }
        return str;
    }
    getTierColor(tier) {
        if (tier == 'uncommon') return '§r§a'
        else if (tier == 'common') return '§r§7'
        else if (tier == 'epic') return '§r§d'
        else if (tier == 'legendary') return '§r§6'
        else if (tier == 'mythical') return '§r§4'
        else return
    }
}
Enchantment.enchatments = []