import { system } from "@minecraft/server"
import { MessageFormData } from "@minecraft/server-ui"

export class MessageForm {
    constructor() {
        this.form = new MessageFormData()
    }
    setTitle(title) {
        system.run(() => this.form.title(title))
        return this
    }
    setBody(body) {
        system.run(() => this.form.body(body))
        return this
    }
    setButton1(name) {
        system.run(() => this.form.button1(name))
        return this
    }
    setButton2(name) {
        system.run(() => this.form.button2(name))    
        return this
    }
    show(player, callback) {
        system.run(() => {            
            this.form.show(player).then((res) => {
                if (!callback) return
                callback(res)
            })
        })
    }
    async force(player, callback, timeout = Infinity) {
        const startTick = system.currentTick;
        while ((system.currentTick - startTick) < timeout) {
            const response = await (this.form.show(player));
            if (response.cancelationReason !== "UserBusy") {
                callback(player, response)
                return response;
            }
        };
        player.response.error('MessageForm cancelled. Reason: timedOut')
    };
}