import { world } from '@minecraft/server';

export class scoreboard {
    
    get(player, objective) {
        try {
            return world.scoreboard.getObjective(objective).getScore(player.scoreboardIdentity);
        } catch { 
            return 0;
        }
    }

    set(player, objective, value = 0) {
        try {
            return player.runCommandAsync(`scoreboard players set @s "${objective}" ${value}`)
        } catch { }
    }
    
    add(player, objective, value = 0) {
        try {
            return player.runCommandAsync(`scoreboard players add @s "${objective}" ${value}`)
        } catch { }
    }

    reset(player, objective) {
        return player.runCommandAsync(`scoreboard players reset @s "${objective}"`)
    }
    remove(player, objective, value = 0) {
        try {
            return player.runCommandAsync(`scoreboard players remove @s "${objective}" ${value}`)
        } catch { }
    }
};