import config from "./config/main.js";

const startPlugins = () => {
  const date = Date.now()
  Object.keys(config.plugins.commands).forEach(category => Object.keys(config.plugins.commands[category]).forEach(cmd => config.plugins.commands[category][cmd] && import(`./plugins/commands/${category}/${cmd}.js`).catch((err) => console.warn(`Failed to import command: ${cmd} from ${category}, ${err} ${err.stack}`))))
  Object.keys(config.plugins.events).forEach(event => config.plugins.events[event] && import(`./plugins/events/${event}`).catch((err) => console.warn(`Failed to import event: ${event}, ${err} ${err.stack}`)))
  import("./API/interval.js")
  return Object.assign(startPlugins, {
    log() {
      return console.warn(`Plugins have been loaded successfully in ${Date.now() - date}MS`)
    }
  })
}
startPlugins().log()