import client from "../../../API/ServerClient";
import { module } from "../../../API/module";
import config from "../../../config/main";

module.exports({
    module: new client.command()
    .setName('auctionhouse')
    .setDescription('An auction house')
    .setCategory('general')
    .setAliases(['ah'])
    .firstArguments(['sell'], false)
    .addDynamicArgument('sell', 'sell', 'price')
    .addNumberArgument('price'),
    execute(ctx) {
        ctx.execute((sender, args) => {
            if (args.length) return
            sender.response.send('Close the chat within 10 secondes')
            new client.actionForm()
            .setTitle('Auction house')
            .setBody('An Auction House!')
            .addButton('All Auctions')
            .addButton('My Auctions')
            .force(sender, (res) => {
                if (res.cancelled) return
                if (res.selection == 0) {
                    const form = new client.actionForm()
                    form.setTitle('Auctions')
                    form.setBody('All Avaliable Auctions: ') 
                    if (!client.auctions.allKeysP().length) {
                        new client.messageForm()
                        .setTitle('No Auctions Available')
                        .setBody('§cHmmm.. seems like theres no auctions to see, maybe add an auction using !ah sell <price>')
                        .setButton2('§cClose')
                        .setButton1('§aOk')
                        .show(sender)
                    } else {
                        client.auctions.forEach((_, val) => {
                            form.addButton(val.itemName + ` By: ${val.creator}`)
                        })
                        form.show(sender, (result) => {
                            if (result.selection < client.auctions.allKeysP().length) {
                                const selection = client.auctions.read(client.auctions.allKeysP()[result.selection])
                                const form = new client.messageForm()
                                .setTitle(selection.itemName + ` By: ${selection.creator}`)
                                .setBody(`§6Creator§e: §c${selection.creator == sender.name ? '§eYou' : selection.creator}\n§6Price§e: §c${selection.price}\n§6Item Name§e: §c${selection.itemName}\n§6Item Enchantments§e: §c${selection.itemData.enchantments == '' ? 'None' : selection.itemData.enchantments}\n§6Item NameTag§e: §c${selection.itemData.nameTag ? selection.itemData.nameTag : 'None'}\n§6Item Amount§e: §c${selection.itemData.amount}`)
                                .setButton1('§cClose')
                                if (selection.key == sender.id) {
                                    form.setButton2('§aRemove Auction')
                                    .show(sender, (res) => {
                                        if (res.cancelled) return
                                        if (res.selection == 1) {
                                            const inventory = sender.getComponent('inventory').container
                                            if (inventory.emptySlotsCount < 1) return sender.response.error('You do not have enough space to remove this item')
                                            inventory.addItem(client.item.newItem(selection.itemData))
                                            sender.response.send(`You have succssfully removed the item ${selection.itemName}`)
                                            client.auctions.delete(selection.key)
                                        }
                                    })
                                } else {
                                    form.setButton2('§aBuy')
                                    .show(sender, (res) => {
                                        if (res.cancelled) return
                                        if (res.selection == 1) {
                                            if (sender.score.getScore(config.currency) < selection.price) return sender.response.error(`You do not have enough ${config.currency}§r§c§lto buy this item`)
                                            const inventory = sender.getComponent('inventory').container
                                            if (inventory.emptySlotsCount < 1) return sender.response.error('You do not have enough space to buy this item')
                                            sender.score.removeScore(config.currency, selection.price)
                                            inventory.addItem(client.item.newItem(selection.itemData))
                                            sender.response.send(`You have succssfully bought the item ${selection.itemName}`)
                                            client.auctionClaims.write(selection.key, selection.price)
                                            client.auctions.delete(selection.key)
                                        }
                                    })
                                }
                            }
                        })
                    }
                } else if (res.selection == 1) {
                    const form = new client.actionForm()
                    .setTitle('All Of Your Auctions')
                    form.setBody('All Auctions that you have made: ')
                    if (!client.auctions.allKeysP().includes(sender.id)) {
                        new client.messageForm()
                        .setTitle('No Auctions Available')
                        .setBody('§cHmmm.. seems like theres no auctions that you have made, maybe add an auction using !ah sell <price>')
                        .setButton2('§cClose')
                        .setButton1('§aOk')
                        .show(sender)
                    } else {
                        client.auctions.forEach((key, val) => {
                            if (key == sender.id) {
                                form.addButton(val.itemName)
                            }
                        })
                        form.show(sender, (result) => {
                            if (result.cancelled) return
                            if (result.selection < client.auctions.allKeysP().length) {
                                const selection = client.auctions.read(client.auctions.allKeysP()[result.selection])
                                new client.messageForm()
                                .setTitle(selection.itemName)
                                .setBody(`§6Creator§e: You\n§6Price§e: §c${selection.price}\n§6Item Name§e: §c${selection.itemName}\n§6Item Enchantments§e: §c${selection.itemData.enchantments == '' ? 'None' : selection.itemData.enchantments}\n§6Item NameTag§e: §c${selection.itemData.nameTag ? selection.itemData.nameTag : 'None'}\n§6Item Amount§e: §c${selection.itemData.amount}`)
                                .setButton1('§cClose')
                                .setButton2('§aRemove Auction')
                                .show(sender, (res) => {
                                    if (res.cancelled) return
                                    if (res.selection == 1) {
                                        const inventory = sender.getComponent('inventory').container
                                        if (inventory.emptySlotsCount < 1) return sender.response.error('You do not have enough space to remove this item')
                                        inventory.addItem(client.item.newItem(selection.itemData))
                                        sender.response.send(`You have succssfully removed the item ${selection.itemName}`)
                                        client.auctions.delete(selection.key)
                                    }
                                })
                            }
                        })
                    }
                }
            }, 220)
        })
        ctx.executeArgument('sell', (sender, _, args) => {
            const inventory = sender.getComponent('inventory').container
            if (!inventory.getItem(sender.selectedSlot)) return sender.response.error('You must hold the item to auction')
            if (config.allCbes.includes(inventory.getItem(sender.selectedSlot).typeId.replace('mincraft:'))) return sender.response.error('You cannot auction that item')
            if (args[0] > 100000000) return sender.response.error('The price cant be bigger than 100000000')          
            if (client.auctions.has(sender.id)) return sender.response.error('You can only auction once at a time')
            client.auctions.write(sender.id, {
                creator: sender.name,
                price: args[0],
                itemName: client.item.getItemName(inventory.getItem(sender.selectedSlot)),
                itemData: client.item.getItemData(inventory.getItem(sender.selectedSlot)),
                key: sender.id
            })
            sender.response.send(`Successfully sold the item ${client.item.getItemName(inventory.getItem(sender.selectedSlot))} for ${args[0]}`)
            inventory.setItem(sender.selectedSlot)
        })
    }
})