import client from "../../../API/ServerClient"
import { module } from "../../../API/module"
import config from "../../../config/main"
import { Commands } from "../../../API/handlers/command"

module.exports({
    module: new client.command()
    .setName('help')
    .setCategory('general')
    .setAliases(['?'])
    .setDescription('Provides you a list of commands or information about a command')
    .firstArguments(['page', 'command'], false)
    .addAnyArgument('command', 1)
    .addNumberArgument('page', [], { min: 0 }),
    execute(ctx) {
        ctx.execute((_, args) => !args.length && ctx.forceValue('page', 1))
        ctx.executeArgument('command', (sender, val) => {
            const cmdList = Commands.registeredCommands.find(c => c.name === val || c.aliases?.includes(val));
            if (!cmdList) return sender.response.error(`Cant find the command ${val}`)
            if (cmdList && cmdList.admin && !sender.permission.hasPermission('admin')) return sender.response.error(`Cant find the command ${val}`) 
            let hI = `§l§6Command: §c${cmdList.name}\n`;
            if (cmdList.description.length) hI += `§6Description:§c ${cmdList.description}\n`;
            if (cmdList.aliases.length) hI += `§l§6Aliases:§c ${cmdList.aliases.join(`§6, §c`)}\n`;
            hI += `§l§6Category:§c ${cmdList.category}\n`;
            if (cmdList.developers.length) hI += `§l§6Developer(s):§c ${cmdList.developers.join('§6 | §c')}\n`;
            let args = []
            Object.keys(cmdList.args).forEach((a) => {
                if (cmdList.argNames[0].includes(a)) return;
                args.push(a)
            })
            if (cmdList.argNames[0].length) hI += `§l§6Argument(s):§c ${cmdList.name} <${cmdList.argNames[0].join(' §a|§c ')}> <${args.join(' §a|§c ')}>\n`;
            sender.response.send(`§6${hI}`, true, false);
        })
        ctx.executeArgument('page', (sender, page) => {
            const cmdList = Commands.registeredCommands.filter(c => sender.permission.hasPermission('admin') ? true : !c.admin)
            const commandList = new Array(Math.ceil(cmdList.length / 35)).fill(0).map(_ => cmdList.splice(0, 35)), help = [], categoryHold = []
            if (!commandList[page - 1]?.[0]) return sender.response.error('Unable to find this page');
            for (const command of commandList[page - 1]) {
                if (!categoryHold.includes(command.category)) help.push(`\n§6<------<[${command.category}§6]>------>`) 
                categoryHold.push(command.category);
                help.push(`§a- ${config.prefix}${command.name} §c- ${command.description}`);
                }
            sender.response.send(`§l${help.join('\n')}\n§6§l<---------->\n§cPage: §a${page}§c/§a${commandList.length}\n§cUse "§6${config.prefix}help §6<Page Number>§c" §cTo see the next page\n§l§6<---------->`, true, false);
        })
    }
})