import client from "../../../API/ServerClient"
import { module } from "../../../API/module"
import config from "../../../config/main"
import { world } from "@minecraft/server"

module.exports({
    module: new client.command()
    .setName('spawn')
    .setDescription('Teleports you to spawn if is set')
    .setCategory('general'),
    execute(ctx) {
        ctx.execute((sender) => {
            if (sender.score.getScore('inCombat') > 0) return sender.response.error(`You are in combat, you must wait ${sender.score.getScore('inCombat')}s before using this command`)
            if (sender.management.jailed) return sender.response.error('You cant use this command while your jailed')
            if (!client.server.has('spawn')) return sender.response.error('There isnt any spawn set yet')
            const spawn = client.server.read('spawn')
            if (Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: spawn.location, maxDistance: Number(config.spawnRaduis) })).some(plr => plr.id == sender.id)) return sender.response.error('Your already in spawn')
            if (config.warpInventoryes) {
                client.warp.warps.forEach((_, v) => {
                    if (Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: v.location, maxDistance: Number(v.raduis) })).some(plr => plr.id === sender.id)) {
                        client.warp.save(sender, v.warp)
                    }
                })
            }
            sender.teleport(client.server.read('spawn').location, { dimension: world.getDimension(client.server.read('spawn').dimension) })
            if (config.warpInventoryes) client.warp.spawnLoad(sender)
            sender.response.send('You have been teleported to spawn')
        })
    }
})