import client from "../../../API/ServerClient";
import { module } from "../../../API/module";
import { ItemTypes } from "@minecraft/server";

module.exports({
    module: new client.command()
    .setName('settings')
    .setDescription('Edit the files config without going thorugh the config file')
    .setCategory('management')
    .setAdmin(true),
    execute(ctx) {
        ctx.execute((sender) => {
            sender.response.send('Close the chat within 10 secondes')
            new client.actionForm()
            .setTitle('Settings')
            .setBody('§aAll that settings the can be edited:')
            .addButton('General Settings\n§7[Click to show]')
            .addButton('Anti Cheat Settings\n§7[Click to show]')
            .addButton('Faction Settings\n§7[Click to show]')
            .force(sender, (res) => {
                if (res.canceled) return
                if (res.selection == 0) {
                    new client.modalForm()
                    .setTitle('General Settings')
                    .addTextField('Admin Tag:', client.settings.read('adminTag'), client.settings.read('adminTag'))
                    .addTextField('Trust Tag:', client.settings.read('trustTag'), client.settings.read('trustTag'))
                    .addTextField('Default Rank:', client.settings.read('defaultRank'), client.settings.read('defaultRank'))
                    .addTextField('Command Prefix:', client.settings.read('prefix'), client.settings.read('prefix'))
                    .addTextField('Chat Style:', client.settings.read('chatStyle'), client.settings.read('chatStyle'))
                    .addTextField('Currency:', client.settings.read('currency'), client.settings.read('currency'))
                    .addToggle('Ranks', client.settings.read('ranks'))
                    .addToggle('Item Names Display', client.settings.read('itemNamesDisplay'))
                    .addToggle('Damage Indicators', client.settings.read('damageIndicators'))
                    .addToggle('Warp/spawn Save and load inventorys', client.settings.read('warpInventorys'))
                    .addToggle('Tree Capitator', client.settings.read('treeCapitator'))
                    .addToggle('Vein Miner', client.settings.read('veinMiner'))
                    .show(sender, (result) => {
                        if (result.canceled) return
                        if (result.formValues[0] == result.formValues[1]) return sender.response.error('The trust tag cnat be the same as the admin tag')
                        if (result.formValues[3].startsWith('/')) return sender.response.error('The command prefix cant be a /')
                        if (result.formValues[3].trim() == '') return sender.response.error('The prefix cant be nothing')
                        client.reWrite('adminTag', result.formValues[0])
                        client.reWrite('trustTag', result.formValues[1])
                        client.reWrite('defaultRank', result.formValues[2])
                        if (result.formValues[4]) client.reWrite('prefix', result.formValues[3])
                        client.reWrite('chatStyle', result.formValues[4])
                        client.reWrite('currency', result.formValues[5])
                        client.reWrite('ranks', result.formValues[6])
                        client.reWrite('itemNamesDisplay', result.formValues[7])
                        client.reWrite('damageIndicators', result.formValues[8])
                        client.reWrite('warpInventorys', result.formValues[9])
                        client.reWrite('treeCapitator', result.formValues[10])
                        client.reWrite('veinMiner', result.formValues[11])
                        sender.response.send('Successfully updated general settings data')
                    })
                } else if (res.selection == 1) {
                    new client.modalForm()
                    .setTitle('Anti Cheat Settings')
                    .addToggle("CBE's", client.settings.read('cbes'))
                    .addToggle('Nuker', client.settings.read('nuker'))
                    .addToggle('Illegal Enchantments', client.settings.read('illegalEnchantments'))
                    .addDropDown('CBE\'s that cant be used from anyone: §c(Select to remove)', ['None', ...client.settings.read('allCbes')])
                    .addDropDown('CBE\'s that can only be used by trusted people: §c(Select to remove)', ['None', ...client.settings.read('trustedCbes')])
                    .addTextField('Add a CBE to all CBE\'s: §c(Only blocks)', 'None')
                    .addTextField('Add a CBE to trusted CBE\'s: §c(Only Blocks)', 'None')
                    .show(sender, (result) => {
                        if (result.canceled) return
                        client.reWrite('cbes', result.formValues[0], 'AntiCheat')
                        client.reWrite('nuker', result.formValues[1], 'AntiCheat')
                        client.reWrite('illegalEnchantments', result.formValues[2], 'AntiCheat')
                        if (!result.formValues[3] == 'None') {
                            const cbes = client.settings.read('allCbes')
                            cbes.splice(cbes.indexOf(cbes[result.formValues[3] - 1]), cbes.indexOf(cbes[result.formValues[3] - 1]))
                            client.reWrite('allCbes', cbes)
                        }
                        if (!result.formValues[4] == 'None') {
                            const Tcbes = client.settings.read('trustedCbes')
                            Tcbes.splice(Tcbes.indexOf(Tcbes[result.formValues[4] - 1]), Tcbes.indexOf(Tcbes[result.formValues[4] - 1]))
                            client.reWrite('trustedCbes', Tcbes)
                        }
                        if (result.formValues[5]) {
                            if (typeof ItemTypes.get(result.formValues[5]) == 'undefined') return sender.response.error('The cbe you tried to add was invalid')
                            
                            if (client.settings.read('allCbes').includes(result.formValues[5].replace('minecraft:', ''))) return sender.response.error('That cbe already exists in the list')
                            const cbes = client.settings.read('allCbes')
                            cbes.push(result.formValues[5].replace('minecraft:', ''))
                            client.reWrite('allCbes', cbes)
                        }
                        if (result.formValues[6]) {
                            if (typeof ItemTypes.get(result.formValues[6]) == 'undefined') return sender.response.error('The cbe you tried to add was invalid')
                            
                            if (client.settings.read('trustedCbes').includes(result.formValues[6].replace('minecraft:', ''))) return sender.response.error('That cbe already exists in the list')
                            const Tcbes = client.settings.read('trustedCbes')
                            Tcbes.push(result.formValues[5].replace('minecraft:', ''))
                            client.reWrite('trustedCbes', Tcbes)
                        }
                        sender.response.send('Successfully updated Anti Cheat settings data')
                    })
                } else if (res.selection == 2) {
                    new client.modalForm()
                    .setTitle('Faction Settings')
                    .addToggle('Claims', client.settings.read('claims'))
                    .addToggle('Allows others to use doors, switches etc. in claims', client.settings.read('toggleAblePermissions'))
                    .addTextField('The raduis from spawn for claims: §c(Only numbers)', 'None')
                    .addTextField('The cost of a claim: §c(Only numbers)', 'None')
                    .show(sender, (result) => {
                        if (result.canceled) return
                        client.reWrite('claims', result.formValues[0])
                        client.reWrite('toggleAblePermissions', result.formValues[1])
                        if (isNaN(result.formValues[2])) return sender.response.error('The amount you entered isnt a number')
                        client.reWrite('spawnRaduis', result.formValues[2])
                        if (isNaN(result.formValues[3])) return sender.response.error('The amount you entered isnt a number')
                        client.reWrite('claimCost', result.formValues[3])
                        sender.response.send('Successfully updated Faction settings data')
                    })
                }
            }, 220)
        })
    }
})