import { world } from "@minecraft/server";
import client from "../../../API/ServerClient";
import { module } from "../../../API/module";
import config from "../../../config/main";

module.exports({
    module: new client.command()
    .setName('warp')
    .setDescription('Create warps for your server')
    .setCategory('management')
    .firstArguments(['create', 'tp', 'delete', 'list'], true)
    .addDynamicArgument('create', 'create', 'warp')
    .addDynamicArgument('tp', 'tp', 'name')
    .addDynamicArgument('delete', 'delete', 'name')
    .addDynamicArgument('list', 'list')
    .addAnyArgument('warp', 1, null, 'raduis')
    .addNumberArgument('raduis')
    .addAnyArgument('name', 1),
    execute(ctx) {
        ctx.executeArgument('tp', (sender, _, args) => {
            if (!client.warp.warps.has(args[0])) return sender.response.error('That warp dosent exist')
            if (config.warpInventoryes) {
                client.warp.warps.forEach((_, v) => {
                    if (Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: { x: v.location.x, y: v.location.y, z: v.location.z }, maxDistance: v.raduis })).some(plr => plr.id === sender.id)) {
                        client.warp.save(sender, v.warp)
                    }
                })
                const spawn = client.server.read('spawn')
                if (spawn?.length && Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: { x: spawn[0], y: spawn[1], z: spawn[2] }, maxDistance: Number(config.spawnRaduis) })).some(plr => plr.id == sender.id)) client.warp.spawnSave(sender)
            }     
            sender.teleport(client.warp.warps.read(args[0]).location, { dimension: world.getDimension(client.warp.warps.read(args[0]).dimension) })
            if (config.warpInventoryes) client.warp.load(sender, args[0])
            sender.response.send(`You have been teleported to the warp: ${args[0]}`)
        })
        ctx.executeArgument('create', (sender, _, args) => {
            if (!sender.permission.hasPermission('admin')) return sender.response.error('You dont have permission to use this argument')
            if (client.warp.warps.has(args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ")[0].toLowerCase().replaceAll(' ', '') + args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ").slice(1).replaceAll(' ', ''))) return sender.response.error('That warp already exists')
            client.warp.warps.write(args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ")[0].toLowerCase().replaceAll(' ', '') + args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ").slice(1).replaceAll(' ', ''), {
                location: { x: sender.location.x, y: sender.location.y, z: sender.location.z },
                raduis: args[1],
                warp: args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ")[0].toLowerCase().replaceAll(' ', '') + args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ").slice(1).replaceAll(' ', ''),
                dimension: sender.dimension.id
            })
            sender.response.send(`Successfully created a warp at your location with the name: ${args[0]?.split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ")[0].toLowerCase().replaceAll(' ', '') + args[0].split(' ').map(v => v[0].toUpperCase() + v.slice(1).toLowerCase()).join(" ").slice(1).replaceAll(' ', '')}`)
        })
        ctx.executeArgument('delete', (sender, _, args) => {
            if (!sender.permission.hasPermission('admin')) return sender.response.error('You dont have permission to use this argument')
            if (!client.warp.warps.has(args[0])) return sender.response.error('That warp dosent exist')
            client.warp.warps.delete(args[0])
            sender.response.send(`Successfully deleted the warp: ${args[0]}`)
        })
        ctx.executeArgument('list', (sender) => {
            sender.response.send(`§c----------------\nAll warps:${client.warp.warps.allKeys()}\n§c----------------`, true, false)
        })
    }
})