import client from "../../../API/ServerClient";
import { module } from "../../../API/module";
import { Area } from "../../../API/handlers/protect";
import config from "../../../config/main";

module.exports({
    module: new client.command()
    .setName('setHome')
    .setDescription('Set a home')
    .setCategory('miscellaneous')
    .firstArguments(['name'], true)
    .addAnyArgument('name', 1),
    execute(ctx) {
        ctx.executeArgument('name', (sender, val) => {
            if (client.homes.has(`${sender.name}:${val}`)) return sender.response.error('That home already exists')
            if (Area.as(sender, [sender.location.x, sender.location.z]).isInArea) return sender.response.error('You cannot set a home here')
            for (const warp of client.warp.warps.allKeysP()) {
                const v = client.warp.warps.read(warp)
                if (Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: { x: v.location.x, y: v.location.y, z: v.location.z }, maxDistance: v.raduis })).some(plr => plr.id === sender.id)) return sender.response.error('You cannot set a home here') 
            }
            const spawn = client.server.read('spawn')
            if (client.server.has('spawn') && Array.from(sender.dimension.getEntities({ type: 'minecraft:player', location: spawn.location, maxDistance: Number(config.spawnRaduis) })).some(plr => plr.id === sender.id)) return sender.response.error(`You have to be further than ${config.spawnRaduis} blocks from spawn`)
            client.homes.write(`${sender.name}:${val}`, {
                name: val,
                creator: sender.name,
                location: { x: sender.location.x, y: sender.location.y, z: sender.location.z },
                dimension: sender.dimension.id
            })
            sender.response.send(`Created the home: ${val}`)
        })
    }
})