import client from "../../API/ServerClient";
import { MinecraftBlockTypes } from "@minecraft/server";
import { Area } from "../../API/handlers/protect";

client.on('BlockPlace', (interaction, data) => {
    if (interaction.permission.hasPermission('admin') && interaction.gamemode.getGamemode() == 'creative') return
    const chunk = [~~((data.block.location.x + 1) / 16), ~~((data.block.location.z + 1) / 16)];
    if (!client.factions.claims.has(`${chunk[0]}_${chunk[1]}`)) return
    if (client.factions.isInFaction(interaction) && client.factions.getPlayersFaction(interaction) == client.factions.claims.read(`${chunk[0]}_${chunk[1]}`).faction) return
    interaction.response.error(`You need to be in the faction ${client.factions.claims.read(`${chunk[0]}_${chunk[1]}`).faction}§r§c§l to be able to place blocks here`)
    data.block.setType(MinecraftBlockTypes.air);
})

client.on('BlockPlace', (interaction, data) => {
    const area = Area.as(interaction, [data.block.location.x, data.block.location.z])
    if (area.isInArea) {
        if (interaction.permission.hasPermission('admin')) return;
        data.interaction.response.error('You cannot place blocks here')
        data.block.setType(MinecraftBlockTypes.air)
    }
})