import client from "../../API/ServerClient";
import { Player, system } from "@minecraft/server";
import { Area } from "../../API/handlers/protect";

client.on('EntityHitBlock', (data) => {
    if (!data.hitBlock || !data.damagingEntity instanceof Player) return
    const player = client.player.convert(data.damagingEntity)
    if (player.gamemode.getGamemode() == 'creative' && player.permission.hasPermission('admin')) return
    const chunk = [~~((data.hitBlock.location.x + 1) / 16), ~~((data.hitBlock.location.z + 1) / 16)];
    if (!client.factions.claims.has(`${chunk[0]}_${chunk[1]}`)) return
    if (client.factions.isInFaction(player) && client.factions.getPlayersFaction(player) == client.factions.claims.read(`${chunk[0]}_${chunk[1]}`).faction) return
    player.response.error(`You need to be in the faction ${client.factions.claims.read(`${chunk[0]}_${chunk[1]}`).faction}§r§c§l to be able to break blocks here`)
    player.runCommandAsync('gamemode a').then(() => {
        system.runTimeout(() => {
            player.runCommandAsync('gamemode s');
        }, 60)
    })
})

client.on('EntityHitBlock', (data) => {
    if (!data.hitBlock || !data.damagingEntity instanceof Player) return
    const player = client.player.convert(data.damagingEntity)
    const area = Area.as(player, [data.hitBlock.location.x, data.hitBlock.location.z])
    if (area.isInArea) {
        if (player.permission.hasPermission('admin')) return;
        player.response.error('You cannot break blocks here')
        player.runCommandAsync('gamemode a').then(() => {
            system.runTimeout(() => {
                player.runCommandAsync('gamemode s');
            }, 60)
        })
    }
})