import client from "../../API/ServerClient";
import { Player, EquipmentSlot } from "@minecraft/server";

client.on('EntityHitEntity', (data) => {
    if (data.damagingEntity instanceof Player && data.hitEntity instanceof Player) {
        if (client.player.convert(data.damagingEntity).score.getScore('inCombat') < 1) data.damagingEntity.onScreenDisplay.setActionBar('§cYou are now in combat')
        client.player.convert(data.damagingEntity).score.setScore('inCombat', 10)
        if (client.player.convert(data.hitEntity).score.getScore('inCombat') < 1) data.hitEntity.onScreenDisplay.setActionBar('§cYou are now in combat')
        client.player.convert(data.hitEntity).score.setScore('inCombat', 10)
        data.hitEntity.addTag('inCombat')
        data.damagingEntity.addTag('inCombat')
    }
    const tools = ['sword', 'pickaxe', 'shovel', 'hoe', 'axe']
    client.enchantment.database.forEach((_, info) => {
        if (info.event == 'OnHit') {
            if (data.damagingEntity instanceof Player) {
                const equipment = data.damagingEntity.getComponent('equipment_inventory')
                if (tools.includes(info.equpiedOn)) {
                    const inv = data.damagingEntity.getComponent('inventory').container
                    for (let i = 1; i < info.maxLevel + 1; i++) {
                        if (!inv.getItem(data.damagingEntity.selectedSlot)) return
                        const lore = `${inv.getItem(data.damagingEntity.selectedSlot).getLore()}`.trim().split(/\s+/g);
                        if (lore.includes(client.enchantment.getTierColor(info.tier) + info.name) && lore[lore.indexOf(client.enchantment.getTierColor(info.tier) + info.name) + 1] == client.enchantment.convertToRoman(i) && inv.getItem(data.damagingEntity.selectedSlot).typeId.endsWith(info.equpiedOn)) {
                            try {
                                data.damagingEntity.runCommandAsync(info.command.replace('$hitEntity', data.hitEntity instanceof Player ? data.hitEntity.name : `@e[type=${data.hitEntity.typeId}, x=${data.hitEntity.location.x}, y=${data.hitEntity.location.y}, z=${data.hitEntity.location.z}]`).replace('$level', i - 1))
                            } catch {}
                        }
                    }
                } else {
                    if (!equipment.getEquipment(EquipmentSlot[info.equpiedOn])) return
                    for (let i = 1; i < info.maxLevel + 1; i++) {
                        const lore = `${equipment.getEquipment(EquipmentSlot[info.equpiedOn]).getLore()}`.trim().split(/\s+/g);
                        if (lore.includes(client.enchantment.getTierColor(info.tier) + info.name) && lore[lore.indexOf(client.enchantment.getTierColor(info.tier) + info.name) + 1] == client.enchantment.convertToRoman(i)) {
                            try {
                                data.damagingEntity.runCommandAsync(info.command.replace('$hitEntity', data.hitEntity instanceof Player ? data.hitEntity.name : `@e[type=${data.hitEntity.typeId}, x=${data.hitEntity.location.x}, y=${data.hitEntity.location.y}, z=${data.hitEntity.location.z}]`).replace('$level', i - 1))
                            } catch {}
                        }
                    }
                }
            }
        }
    })
})