import { world, Vector } from '@minecraft/server';
import client from '../../API/ServerClient';
import config from '../../config/main';

function random(min, max) {
    return Math.random() * (max - min) + min;
}
function indicator(player, text, vector=[0, 0.1,0], offset=[random(-1, 1), -0.5, random(-1, 1)]) {
    const {x, y,z} = player.location
    const h = world.getDimension(`overworld`).spawnEntity('mod:damage_entity', new Vector(x + offset[0], y + offset[1], z + offset[2]))
    h.nameTag = text
    h.applyImpulse(new Vector(vector[0], vector[1], vector[2]))
}

client.on('EntityHurt', (data) => {
    if (config.damageIndicators) indicator(data.hurtEntity, `§c§l${data.damage / 2}`, [0, -0.1, 0], [random(-1, 1), 0.5, random(-1, 1)])
})